<template>
  <el-dialog v-model="show" align-center custom-class="common-login-dialog" :style="[isHasScrollbar ? 'right: 8px !important;': '']">
    <template #title>
      <div class="bg-background5 rounded-t-2xl">
        <div class="h-[64px] bg-black bg-opacity-20 flex items-center py-0 pl-[40px] pr-[16px]">
          <h1 class="text-left text-2xl font-bold text-[var(--secondary)]">{{ $t('login') }}</h1>
        </div>
      </div>
      <div class="w-full h-[2px] bg-border"></div>
    </template>
    <el-row class="login w-[1200px]">
      <el-col class="w-[400px] py-6 px-10 bg-background5 h-[654px] overflow-hidden rounded-bl-2xl">
        <el-form
            ref="loginFormRef"
            :model="loginFormData"
            :rules="loginRules"
            :validate-on-rule-change="false"
            label-position="left"

          >
            <el-form-item :label="$t('username')" prop="Username">
              <el-input
              v-model="loginFormData.Username"
              :disabled="isLoginProccessing"
              type="text"/>
            </el-form-item>
            <el-form-item :label="$t('password')" prop="Password">
              <el-input
              v-model="loginFormData.Password"
              :disabled="isLoginProccessing"
              type="password"/>
            </el-form-item>
            <el-divider class="bg-border" />
            <div class="btn-click-captcha-to-verify mt-2">
              <el-form-item
              v-if="!clientCaptcha.IsHidden"
              prop="Captcha"
              :show-message="true"
              >
                <div id="captcha-button">
                  <div id="captcha-pop-up-verify" class="w-full">
                    <template v-if="!captchaErrorMsg.length && loginFormData.Captcha.length == 5 && !isDialogVisible">
                      <div class="relative w-[18px] h-[18px]">
                        <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png')"
                          alt="verify icon success" loading="lazy">
                      </div>
                      <span class="whitespace-nowrap">{{ $t('successful_verification') }}</span>
                    </template>
                    <template v-else>
                      <div class="flex justify-center items-center gap-1 w-full" @click="isDialogVisible = true">
                        <div class="relative w-[18px] h-[18px]">
                          <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/capcha.png')"
                            alt="verify icon" loading="lazy">
                        </div>
                        <span>{{ $t('click_to_verify') }}</span>
                      </div>
                    </template>
                  </div>
                </div>
              </el-form-item>
            </div>
            <div class="mt-5 text-center">
              <el-button v-on:click="submitLogin(loginFormRef)" :disabled="isLoginProccessing" class="px-4 py-1 text-sm w-full rounded btn bg-secondary"><b>{{ $t('login') }}</b></el-button>
            </div>
            <el-form-item class="forgot-password-form-item" :class="themeColor ? themeColor.Text : ''">
              <auth-forgot-password-modal />
            </el-form-item>
            <div>
              <div v-if="!register.IsHidden" class="text-center fc-text4">{{ $t('dont_have_an_account?') }}
                <nuxt-link
                  class="text-primary underline cursor-pointer"
                  to="/register"
                  >{{ $t("joinnow") }}</nuxt-link
                >
              </div>
            </div>
          </el-form>
      </el-col>
      <el-col class="relative register-info w-[800px] h-[654px] flex justify-center text-center rounded-br-2xl bg-background5">
        <div class="flex justify-center flex-col">
          <div class="absolute w-full h-full inset-0 bg-black opacity-10"></div>
          <div class="w-[752px] h-[504px]">
            <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
          </div>
          <div class="text-primary text-2xl font-black mb-1">
            <span>{{ $t('welcome_to') }}</span>
            <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
          </div>
          <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
        </div>
      </el-col>
    </el-row>
    <div class="captcha-dialog-container">
      <el-dialog
        align-center
        destroy-on-close
        :show-close="false"
        custom-class="p-[15px] captcha-dialog"
        v-model="isDialogVisible"
        width="320px"
        @open="loginFormData.Captcha = ''"
        @close="loginFormRef?.validateField('Captcha')"
        >
        <utils-client-captcha v-if="!clientCaptcha.IsHidden" v-model:captcha="loginFormData.Captcha"
          v-model:dialogVisible="isDialogVisible" :get-error-message="getCaptchaErrorMsg"
          :is-invalid="captchaErrorMsg.length > 0" />
      </el-dialog>
    </div>
  </el-dialog>
</template>
<script lang="ts">
import { defineComponent, ref } from "vue";
import useLogin from "@/composables/useLogin";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from "~~/store";
import commonHelper from "@/utils/commonHelper";
import { clientCaptcha } from '@/composables/captcha/useCaptcha';

export default defineComponent({
  name: "LoginDialog",
  props: {
    value: Boolean,
  },
  setup(props) {
    const { getAssetImage } = commonHelper;
    const show = ref(props.value);
    const isDialogVisible = ref(false);
    const themeProperties = computed(() => store.state.companyThemePropertiesFromApi.ThemeProperties);
    const themeColor = computed((): IThemePropertiesFromApi => themePropertyHelper.getSingleThemeProperty(themeProperties.value, 'theme_color'));
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const isHasScrollbar = ref(false);
    setTimeout(() => {
      isHasScrollbar.value = document.body.clientHeight - window.innerHeight > 0;
    }, 100);

    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      register,
    } = useLogin();
    return {
      themeColor,
      getCaptchaErrorMsg,
      captchaErrorMsg,
      isDialogVisible,
      getAssetImage,
      loginRegister,
      companyName,
      show,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      clientCaptcha,
      isHasScrollbar,
      register,
    };
  },
});
</script>
<style>
.el-dialog.is-align-center.common-login-dialog {
  --el-dialog-bg-color: none;
  width: 1200px;
}
.el-dialog.is-align-center.common-login-dialog:focus-visible {
  outline: 0;
}
.common-login-dialog .el-dialog__header {
  padding: 0px;
  margin: 0px;
}
.common-login-dialog .el-dialog__body {
  padding: 0px;
}
.common-login-dialog .el-dialog__headerbtn {
  z-index: 99;
  position: absolute;
  width: 30px;
  height: 30px;
  right: 25px;
  top: 18px;
  background: var(--primary);
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
}
.common-login-dialog .el-dialog__headerbtn .el-dialog__close {
  color: unset;
  font-size: 25px;
}
.captcha-dialog-container .el-dialog{
  height: 230px;
}
</style>
<style scoped>
:deep(.btn-dialog-login .el-form-item__content) {
  justify-content: center;
}
.login{
  display: block;
}
.el-form-item {
  display: block;
  margin-bottom: 16px;
}
.text-primary {
  color: var(--primary);
}
.el-button.is-round {
  border-radius: 4px;
}
:deep(.forgot-password-form-item .el-form-item__content) {
  margin: 0;
  justify-content: center;
  line-height: 0;
  margin-top: 20px;
}
:deep(.el-form-item__label) {
  color: var(--text5);
}
.el-divider--horizontal{
  margin: 0;
}
</style>
